/* ------------------------------------------------------------------------- */
/*
 *  constrained_value_func.h
 *
 *  Copyright (c) 2004 - 2006 "clown". All rights reserved.
 *
 *  Permission to copy, use, modify and distribute this software is
 *  granted provided this copyright notice appears in all copies.
 *  This software is provided "as is" without express or implied
 *  warranty, and with no claim as to its suitability for any purpose.
 *
 *  Reference: D. Ryan Stephens, Christopher Diggins, Janathan Turkanis,
 *  and Jeff Cogswell, ``C++ Cookbook,'' O'Reilly Media, Inc, 2006.
 *
 *  Last-modified: Mon 11 Dec 2006 04:02:00 JST
 */
/* ------------------------------------------------------------------------- */
#ifndef CLX_CONSTRAINED_VALUE_FUNC_H
#define CLX_CONSTRAINED_VALUE_FUNC_H

#include <stdexcept>

namespace clx {
	/* --------------------------------------------------------------------- */
	//  ranged_integer
	/* --------------------------------------------------------------------- */
	template <int Min, int Max>
	class ranged_integer {
	public:
		typedef int value_type;
		const static value_type default_value = Min;
		
		static void assign(value_type& dest, const value_type& src) {
			if ((src < Min) || (src > Max)) {
				throw std::range_error("out of valied range");
			}
			dest = src;
		}
	};
};

#endif // CLX_CONSTRAINED_VALUE_FUNC_H
